#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>

/* Program ilustruje dzialanie timera0 w trybie generowania sygnalu fast PWM.
   Dwa przyciski sluza do zmniejszania lub zwiekszania wspolczynnika wypelnienia PWM,
   co przeklada sie na obserwowalna zmiane jasnosci swiecenia diody LED. */

void FastPWMTimer0Config()
{
   TCCR0|=(1<<WGM00)|(1<<WGM01);//fast PWM
   TCCR0|=(1<<COM01); //non-inverting mode
   TCCR0|=(1<<CS02)|(1<<CS00); //preskaler 1024: clock wejsciowy to 16 MHz/1024=15625 Hz
   OCR0=0; //poczatkowa wartosc wypelnienia
}

int main(void)
{
   FastPWMTimer0Config();
   DDRB=0xFF;
	while(1) {
		if(bit_is_clear(PIND,0)) //jezeli wcisnieto przycisk (pierwszy z lewej na plytce AVR-KC)
		{
		   if(OCR0>0) //zabezpieczenie przed przepelnieniem w dol
		   {
		     OCR0--; //zmniejszanie wartosci wypelnienia - jasnosc diody sie zmniejsza
		   }
		}
		if(bit_is_clear(PIND,1)) //jezeli wcisnieto przycisk (drugi z lewej na plytce AVR-KC)
		{
		    if(OCR0<255) //zabezpieczenie przed przepelnieniem w gore
			{
		       OCR0++; //zwiekszanie wartosci wypelnienia - jasnosc diody sie zwieksza
			}
		}
		_delay_ms(5); //opoznienie programowe 5 milisekund
	}
}