#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

/* Program realizuje odmierzanie okreslonej ilosci czasu z wykorzystaniem timera1
   pracujacego w trybie CTC. Kazdy przebyty interwal czasowy jest sygnalizowany 
   poprzez wykonanie fragmentu kodu znajdujacego sie w procedurze obslugi przerwania. */

ISR(TIMER1_COMPA_vect) //obsluga przerwania od zgodnosci TCNT1 z OCR1A
{
   PORTB=~PORTB; //cykliczna negacja calego portu - wlaczanie/wylaczanie diod LED
}

void Timer1Config()
{
   TCCR1B|=(1<<CS12)|(1<<CS10); //preskaler 1024 (szczegoly w dokumentacji)
   TCCR1B|=(1<<WGM12); //tryb CTC, MAX wartosc, do ktorej zlicza licznik znajduje sie w rejestrze OCR1A
   TIMSK|=(1<<4); //wlaczenie przerwania przy compare match (zrownanie sie TNCNT1 i OCR1A spowoduje wywolanie przerwania)
   SREG|=(1<<7); //wlaczenie przerwan globalnych, robi to samo co instrukcja sei();
   OCR1A=15000; //wartosc, do ktorej zlicza licznik
}

int main(void)
{
   Timer1Config(); 
   DDRB=0xFF;
	while(1) {
	}
}