#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

/* Prosty program realizujacy obsluge programowego PWM.
   Wypelnienie PWM jest ustawiane poprzez zmienna PWM_value.
   Czestotliwosc fali PWM mozna zmieniac poprzez OCR1A oraz
   dzieki zmianie wartosci preskalera taktujacego timer1
   (bity CS10, CS11, CS12-szczegoly w dokumentacji). */

uint8_t PWM_counter; //licznik - programowy odpowiednik TCNT w timerach
uint8_t PWM_value=50; //wartosc wypelnienia PWM - wstepnie 50/255

ISR(TIMER1_COMPA_vect)  //procedura obslugi przerwania
{
	if(PWM_counter<PWM_value) //jezeli licznik nie doliczyl jeszcze do ustalonego PWM_value
	{
		PORTB=0xFF; //zapalenie diod led
	}
	else //gdy przekroczono prog rownosci PWM_counter i PWM_value
	{ 
		PORTB=0x00; //wylaczenie diod led
	}
   PWM_counter++; //zliczanie licznika w gore
}

void Timer1Config()
{
   TCCR1B|=(1<<CS12)|(1<<CS10); //preskaler 1024
   TCCR1B|=(1<<WGM12); //tryb CTC, MAX wartosc w rejestrze OCR1A
   TIMSK|=(1<<4); //wlaczenie przerwania przy compare match
   SREG|=(1<<7); //wlaczenie przerwan globalnych, robi to samo co instrukcja sei();
   OCR1A=100; 
}

int main(void)
{
   Timer1Config();
   DDRB=0xFF;
	while(1) {
	}
}